---@type Tinkr
local Tinkr,
---@class Bastion
Bastion = ...

local Class = Tinkr.Util.Class

---@class Bastion.Object
---@field unit WowGameObject
local Object = {}

function Object:__index(k)
    if k == "unit" then
        return rawget(self, k)
    end

    local response = Bastion.ClassMagic:Resolve(Object, k)

    if response == nil then
        response = rawget(self, k)
    end

    if response == nil then
        error("Object:__index: " .. k .. " does not exist")
    end

    return response
end

---@param unit WowGameObject
function Object:New(unit)
    ---@class Bastion.Object
    local self = setmetatable({ unit = unit }, Object)
    return self
end

function Object:Creator()
    return self.unit:creator()
end

function Object:Distance(target)
    return self.unit:distance(target)
end

function Object:Flags()
    return self.unit:flags()
end

function Object:GameObjectType()
    return self.unit:gameObjectType()
end

function Object:Guid()
    return self.unit:guid()
end

function Object:Hash()
    return self.unit:hash()
end

function Object:Height()
    return self.unit:height()
end

function Object:Id()
    return self.unit:id()
end

function Object:IsOutdoors()
    return self.unit:isOutdoors()
end

function Object:IsSubmerged()
    return self.unit:isSubmerged()
end

function Object:Lootable()
    return self.unit:lootable()
end

function Object:ModelID()
    return self.unit:modelID()
end

function Object:MovementFlag()
    return self.unit:movementFlag()
end

function Object:Mover()
    return self.unit:mover()
end

function Object:Name()
    return self.unit:name()
end

function Object:RawPosition()
    return self.unit:rawPosition()
end

function Object:Position()
    return self.unit:position()
end

function Object:WorldPosition()
    return self.unit:worldPosition()
end

function Object:RawRotation()
    return self.unit:rawRotation()
end

function Object:Rotation()
    return self.unit:rotation()
end

function Object:RightClick()
    return self.unit:rightClick()
end

function Object:Sparkling()
    return self.unit:sparkling()
end

function Object:Type()
    return self.unit:type()
end
